> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tight.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Save dimensions

> Save a new (or update an existing) set of dimensions



## OpenAPI

````yaml https://dev.tight.com/v3/api-docs post /v6/templates/dimensions
openapi: 3.0.1
info:
  title: Tight API
  contact:
    name: Hurdlr, Inc. (dba Tight)
    url: https://www.tight.com
    email: api@tight.com
  version: 6.0.0
servers:
  - url: https://sandbox.tight.com
    description: Staging Environment
  - url: https://prod.tight.com
    description: Production Environment
security:
  - EmbedToken: []
paths:
  /v6/templates/dimensions:
    post:
      tags:
        - Templates
      summary: Save dimensions
      description: Save a new (or update an existing) set of dimensions
      operationId: postDimensions
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MultiParamDimensionPostDto'
        required: true
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseListMultiResponseDimensionGetDto'
        '207':
          description: Some dimensions failed to save. See response body for error details.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseListMultiResponseDimensionGetDto'
        '400':
          description: All dimensions failed to save.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseListMultiResponseDimensionGetDto'
        '401':
          description: Not authenticated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: INVALID_TOKEN
                    message: Invalid access token
        '403':
          description: Not authorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: FORBIDDEN
                    message: Expired access token
        '404':
          description: Endpoint not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: BAD_REQUEST
                    message: Resource not found
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: UNKNOWN_ERROR
                    message: Something went wrong. Please try again later.
      security:
        - PartnerAuth: []
components:
  schemas:
    MultiParamDimensionPostDto:
      required:
        - data
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/DimensionPostDto'
    ResponseListMultiResponseDimensionGetDto:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        data:
          type: array
          description: The data generated by the action performed.
          items:
            $ref: '#/components/schemas/MultiResponseDimensionGetDto'
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
    ErrorResponse:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        data:
          type: object
          description: The data generated by the action performed.
          nullable: true
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
    DimensionPostDto:
      required:
        - name
      type: object
      properties:
        id:
          type: string
          description: Id of the dimension, required when updating an existing dimension
          example: tdim_439511
        parentId:
          type: string
          description: Parent dimension ID for hierarchical structure
          nullable: false
          example: tdim_439511
        name:
          type: string
          description: Name of the dimension
          nullable: false
          example: Job Site
        status:
          type: string
          description: Status of the dimension (defaults to ACTIVE if not provided)
          nullable: false
          example: ACTIVE
          enum:
            - ACTIVE
            - INACTIVE
            - REMOVED
            - ACTIVE
            - INACTIVE
        requiredness:
          type: string
          description: >-
            Whether this dimension is required for transactions (defaults to
            NOT_REQUIRED if not provided)
          nullable: false
          example: NOT_REQUIRED
          enum:
            - REQUIRED
            - NOT_REQUIRED
            - REQUIRED
            - NOT_REQUIRED
    MultiResponseDimensionGetDto:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        statusCode:
          $ref: '#/components/schemas/HttpStatus'
        data:
          $ref: '#/components/schemas/DimensionGetDto'
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
      description: The data generated by the action performed.
    ErrorItem:
      type: object
      properties:
        type:
          type: string
          description: The type of the error. Safe for programmatic use.
          enum:
            - UNKNOWN_ERROR
            - INVALID_TOKEN
            - EXPIRED_TOKEN
            - FORBIDDEN
            - BAD_REQUEST
            - JSON_ERROR
            - DUPLICATE
            - REQUIRED
            - INVALID_VALUE
            - NOT_MODIFIABLE
            - INVALID_FORMAT
            - NOT_FOUND
        message:
          type: string
          description: >-
            A human-readable message providing more details about the error.
            Safe for displaying to a user.
        param:
          type: string
          description: >-
            If the error is parameter-specific, the parameter related to the
            error. This can be used to display a message near the correct form
            field.
      description: Errors associated with the action performed, if applicable.
    HttpStatus:
      type: integer
      description: The HTTP status code for the action performed.
      format: int32
      enum:
        - 200
        - 400
        - 401
        - 403
        - 404
        - 500
    DimensionGetDto:
      required:
        - child
        - id
        - name
        - requiredness
        - status
      type: object
      properties:
        id:
          type: string
          description: Id of the dimension
          example: tdim_123456
        name:
          type: string
          description: Name of the dimension
          example: Job Site
        status:
          type: string
          description: Status of the dimension
          example: ACTIVE
          enum:
            - ACTIVE
            - INACTIVE
            - REMOVED
        requiredness:
          type: string
          description: Requiredness of the dimension
          example: NOT_REQUIRED
          enum:
            - REQUIRED
            - NOT_REQUIRED
        child:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/DimensionGetDto'
      description: List of dimensions
  securitySchemes:
    EmbedToken:
      type: http
      description: >-
        Bearer authentication header of the form `Bearer <token>`, see
        [Authentication for more
        detail](/api-reference/authentication#partner-level-authentication).
      scheme: bearer
    PartnerAuth:
      type: http
      description: >-
        Bearer authentication header of the form `Bearer <token>`, where
        `<token>` is a [partner-level
        token](/api-reference/authentication#partner-level-authentication).
      scheme: bearer

````